"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.node = node;
exports.user = void 0;

var _ldflex = require("ldflex");

var _ldflexComunica = _interopRequireDefault(require("ldflex-comunica"));

var _solidAuthClient = _interopRequireDefault(require("solid-auth-client"));

var _context = _interopRequireDefault(require("./context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const factory = new _ldflex.QueryPathFactory({
  context: _context.default
});
/**
 * Starts a query path from the given subject
 */

function node(subject) {
  const queryEngine = new _ldflexComunica.default(subject);
  return factory.create({
    queryEngine
  }, {
    subject
  });
}
/**
 * Starts a query path from the currently logged in user
 */


const user = new _ldflex.QueryPath({
  resolvers: [{
    supports() {
      return true;
    },

    resolve(path, property) {
      // Obtain the user's WebID
      const webId = _solidAuthClient.default.currentSession().then(session => {
        if (!session) throw new Error('Path expression with "user" failed: no active user');
        return session.webId;
      }); // Start a new path from the user


      return node(webId)[property];
    }

  }]
});
exports.user = user;